local _, ns = ...
ns.WhoKnows = {}
local WK = ns.WhoKnows
WK.DebugBox = CreateFrame('Frame', '_DebugBox', UIParent)
local DebugBox = WK.DebugBox
-------------------------------------------------------

DebugBox:SetWidth(500)
DebugBox:SetHeight(400)
DebugBox:SetPoint('LEFT', UIParent, 'LEFT', 3, 10)
DebugBox:SetFrameStrata('DIALOG')
DebugBox:EnableMouse(true)
DebugBox:SetMovable(true)
DebugBox:SetResizable(true)
DebugBox:RegisterForDrag("LeftButton")
DebugBox:SetUserPlaced(true)
DebugBox:SetBackdrop({
      bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
      edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
      tile = true, tileSize = 16, edgeSize = 16,
      insets = { left = 5, right = 5, top = 5, bottom = 5 }
})
DebugBox:SetBackdropColor(0, 0, 0, 1)
DebugBox:SetClampedToScreen(true)
DebugBox:SetMinResize(200, 100)
DebugBox:SetFrameStrata("Low")
---------
DebugBox.Drag = CreateFrame("Button", nil, DebugBox)
DebugBox.Drag:SetPoint("TOPLEFT", DebugBox, "TOPLEFT", 10,-5)
DebugBox.Drag:SetPoint("TOPRIGHT", DebugBox, "TOPRIGHT", -10,-5)
DebugBox.Drag:SetHeight(16)
DebugBox.Drag:SetNormalTexture("Interface\\WorldMap\\UI-QuestPoi-HighlightBar")
DebugBox.Drag:SetScript("OnMouseDown", function() DebugBox:StartMoving() end)
DebugBox.Drag:SetScript("OnMouseUp", function() DebugBox:StopMovingOrSizing() end)
DebugBox.Drag:SetFrameStrata("Low")
DebugBox.Drag:Raise()
--DebugBox.Drag:SetText("Debug Frame")
---------
DebugBox.closeBtn = CreateFrame("Button","CloseBtn", DebugBox, "UIPanelCloseButton")
DebugBox.closeBtn:SetPoint("TOPRIGHT",10,10)


	DebugBox.debugOff  = CreateFrame("Button", "debugOff", DebugBox, "UIPanelButtonTemplate")
	DebugBox.debugOff:SetPoint("TOPRIGHT",-50,-3)
	DebugBox.debugOff:SetText("Debug Off")
	DebugBox.debugOff:SetWidth(100)
	DebugBox.debugOff:SetHeight(18)
	DebugBox.debugOff:Raise()
	DebugBox.debugOff:SetScript("OnClick", function(self, button, down)
        WK.debugPrint("turning off debug")
        WK.debug = false
        WhoKnows_Data.enableDebug = false
		DebugBox:Hide()
	end)
	DebugBox.debugOff:SetFrameStrata("Medium")
---------
DebugBox.Box = CreateFrame("ScrollingMessageFrame", "DebugBoxEditBox", DebugBox)
DebugBox.Box:SetPoint("TOPLEFT",10,-25)
DebugBox.Box:SetFading(false)
DebugBox.Box:SetJustifyH("LEFT")
DebugBox.Box:SetWidth(DebugBox:GetWidth() - 50)
DebugBox.Box:SetHeight(DebugBox:GetHeight() - 50)
DebugBox.Box:SetFontObject(GameFontNormal)
DebugBox.Box:SetIndentedWordWrap(true)
DebugBox.Box:EnableMouse(true)
DebugBox.Box:EnableMouseWheel(true)
DebugBox.Box:SetMaxLines(150)

DebugBox.Box:SetScript("OnMouseWheel", function(self, delta)
     if delta == 1 then
		DebugBox.Box:ScrollUp()
	else
		DebugBox.Box:ScrollDown()
	end
end)
--[[
DebugBox.scroll = CreateFrame("Slider", nil, DebugBox.Box, "UIPanelScrollBarTemplate")
DebugBox.scroll:SetPoint("TOPLEFT", frame, "TOPRIGHT", 4, -16)
DebugBox.scroll:SetPoint("BOTTOMLEFT", frame, "BOTTOMRIGHT", 4, 16)
DebugBox.scroll:SetMinMaxValues(1, 200)
DebugBox.scroll:SetValueStep(1)
DebugBox.scroll.scrollStep = 1
DebugBox.scroll:SetValue(0)
DebugBox.scroll:SetWidth(16)
DebugBox.scroll:SetScript("OnValueChanged",
	function (self, value)
		DebugBox.Box:SetVerticalScroll(value or 1)
	end)
local scrollbg = DebugBox.scroll :CreateTexture(nil, "BACKGROUND")
scrollbg:SetAllPoints(DebugBox.scroll )
scrollbg:SetTexture(0, 0, 0, 0.4)
DebugBox.scrollbar = DebugBox.scroll
]]--

DebugBox.Box:SetScript("OnHyperlinkClick", function(self, linkData, link, button)
	if button == "RightButton" then
		DebugCopyBox:SetText(link)
		DebugCopyBox:HighlightText()
		DebugCopyBox:Show()
	elseif IsControlKeyDown() then
		watch(linkData)
	else
		texplore(linkData,_G[linkData],tonumber(5))
	end
end)

DebugBox:SetScript("OnSizeChanged", function(self,x,y)
	DebugBox.Box:SetWidth(x-50)
	DebugBox.Box:SetHeight(y-50)
end)
---------
local DebugBoxResizer = CreateFrame("Frame","Resizer", DebugBox)
DebugBoxResizer:SetPoint("BOTTOMRIGHT",0,0)
DebugBoxResizer:SetSize(15,15)
DebugBoxResizer:SetScript("OnMouseDown", function(self)
	self:GetParent():StartSizing("BOTTOMRIGHT");
end)
DebugBoxResizer:SetScript("OnMouseUp", function(self)
	self:GetParent():StopMovingOrSizing();
end)
DebugBoxResizer:CreateTexture("DebugBoxResizerTexture","BACKGROUND")
DebugBoxResizerTexture:SetAllPoints()
DebugBoxResizerTexture:SetTexture("Interface\\AddOns\\Watch\\Grabber")
DebugBoxResizerTexture:SetBlendMode("ADD")
---------
local DebugCopyBox = CreateFrame("EditBox","DebugCopyBox", DebugBox)
DebugCopyBox:SetPoint("TOPLEFT", DebugBox, "BOTTOMLEFT", 0, -15)
DebugCopyBox:SetSize(400, 50)
DebugCopyBox:SetFontObject(GameFontNormal)
DebugCopyBox:SetMultiLine(false)
DebugCopyBox:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background"})
DebugCopyBox.closeBtn = CreateFrame("Button","CloseBtn", DebugCopyBox, "UIPanelCloseButton")
DebugCopyBox.closeBtn:SetPoint("RIGHT",5,0)
DebugCopyBox:Hide()

function DebugBox:AddLine(msg)
	DebugBox.Box:AddMessage(msg)
	DebugBox.Box:ScrollToBottom()
end

function ToggleDebugBox(self)
	if DebugBox:IsVisible() then
		DebugBox:Hide()
	else
		DebugBox:Show()
	end
end
DebugBox:Hide()
